/*
 *
 */

#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>

#include   "pokesound.h"

static Symbol	symbols[SYM_NB_SYMBOLS];

/* -------------------------------------------------------------- */

void symb_init(int k)
{
fprintf(stderr, ">>> %s ( %d )\n", __func__, k);

memset(symbols, 0, sizeof(Symbol) * SYM_NB_SYMBOLS);	
}
/* -------------------------------------------------------------- */
int	symb_count_free(int k)
{
int	idx, count;

fprintf(stderr, ">>> %s ( %d )\n", __func__, k);

for (count=0, idx=0; idx<SYM_NB_SYMBOLS; idx++) {
	if (0 == symbols[idx].type)  count++;
	}

return count;
}
/* -------------------------------------------------------------- */
int symb_index(char *name)
{
int	idx;

fprintf(stderr, ">>> %s ( '%s' )\n", __func__, name);

for (idx=0; idx<SYM_NB_SYMBOLS; idx++) {
	if ( ! strcmp(name, symbols[idx].name) ) {
		fprintf(stderr, "    found at %d\n", idx);
		return idx;
		}
	}
return -1;
}
/* -------------------------------------------------------------- */
/*
 *	add a symbol (name, type, *datas) to the table
 */
int symb_insert(char *name, int type, void *data)
{
int	idx, found;

fprintf(stderr, ">>> %s ( '%s'  %d  %p )\n", __func__,
				name, type, data);

/*
 *	seek for a free slot
 */
found = -1;
for (idx=0; idx<SYM_NB_SYMBOLS; idx++) {
	if (0 == symbols[idx].type) {
		found = idx;
		fprintf(stderr, "    free slot at %d\n", found);
		break;
		}
	}
if (-1 == found) {			// no free slot ;(
	fprintf(stderr, "ERR in %s: no free symbol slot\n", __func__);
	exit(1);
	}

strncpy(symbols[idx].name, name, SYM_SZ_NAME);
symbols[idx].data  = data;
symbols[idx].type  = type;
symbols[idx].flags = 0x55;

return 0;
}
/* -------------------------------------------------------------- */
SndPk_sndbuff *symb_get_addr(char *name)
{
int	index;

fprintf(stderr, ">>> %s ( '%s' )\n", __func__, name);

index = symb_index(name);
if (index < 0) {
	fprintf(stderr, "    symb '%s' not found\n", name);
	return NULL;
	}

return symbols[index].data;
}
/* -------------------------------------------------------------- */
int symb_list(char *title)
{
int		idx;

fprintf(stderr, "+--------- %s\n", title);
for (idx=0; idx<SYM_NB_SYMBOLS; idx++) {
	if (0 != symbols[idx].type) {
		fprintf(stderr, "| %4d   %-16s  %p   %3d   0x%04x\n", 
			idx,
			symbols[idx].name, symbols[idx].data,
			symbols[idx].type, symbols[idx].flags);
		}
	}
fprintf(stderr, "+--------- %s\n", title);
return 0;
}
/* -------------------------------------------------------------- */
